//+------------------------------------------------------------------+
//|                                         ForexTSD_Calendar_v1.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#include <WebGet.mqh>

#property indicator_chart_window

extern string     CalendarName     = "ForexTSD";
extern int        CalendarID       =       4; // Calendar's ID on calendar.forex-tsd.com  
extern int        TimeZone         =       0; // Difference between broker time and server time   
extern bool       UseStartDate     =   false; 
extern string     StartDate        = "20070410";      
extern bool       AlertMode        =   false;
extern int        AlertTimeGap     =       1; // Time Gap between News Time and Alert Time in min 
extern bool       DisplayLine      =   true; // Display Line Option (Visualization mode) 
extern bool       DisplayText      =   true; // Display Text Option (Visualization mode)

extern string     cFilter          = " Currency Filter ";
extern bool       USD              =    true;
extern bool       EUR              =    true;
extern bool       GBP              =    true;
extern bool       JPY              =    true;
extern bool       AUD              =    true;
extern bool       CAD              =    true;
extern bool       CHF              =    true;
extern bool       NZD              =    true;

extern string     rFilter          = " Rating Filter ";
extern int        MaxRating        =       3;
extern int        MinRating        =       1;  

string   sDate[1000];          // Date
string   sTime[1000];          // Time
string   sCurrency[1000];      // Currency
string   sDescription[1000];   // Description
string   sRating[1000];        // Rating
datetime dt[1000];    
int      NewsNum;
bool     fTime;
datetime prevTime, nTime;

string pair; 
string cntry1; 
string cntry2; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   fTime = true;
	pair = Symbol();
	cntry1 = StringSubstr(pair, 0, 3);
	cntry2 = StringSubstr(pair, 3, 3);   
//----
   return(0);
  }
//-----
void ReadnPlotCalendar(string fName)
{    
   int i,handle;
     
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
      if(handle<1)
      {
      Print("File not found ", GetLastError());
      return(false);
      }
   i=0;
   while(!FileIsEnding(handle))
   {
   sDate[i]=FileReadString(handle);          // Date
   sTime[i]=FileReadString(handle);          // Time
   sCurrency[i]=FileReadString(handle);      // Currency
   sDescription[i]=FileReadString(handle);   // Description
   sRating[i]=FileReadString(handle);       // Rating
   
   //Print("Date=",sDate[i]," time=",sTime[i]);                        
      
   if ((sCurrency[i] == "USD") && (!USD)) continue;            
   if ((sCurrency[i] == "EUR") && (!EUR)) continue;            
   if ((sCurrency[i] == "GBP") && (!GBP)) continue;                      
   if ((sCurrency[i] == "JPY") && (!JPY)) continue;
   if ((sCurrency[i] == "AUD") && (!AUD)) continue;
   if ((sCurrency[i] == "CAD") && (!CAD)) continue;                     
   if ((sCurrency[i] == "CHF") && (!CHF)) continue;  
   if ((sCurrency[i] == "NZD") && (!NZD)) continue;   
      
   int rating = StrToInteger(sRating[i]);
   
      if ( rating <= MaxRating && rating >= MinRating)    
      {
   
      dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
   
      string info = i+"_"+TimeToStr(dt[i])+" "+sCurrency[i]+" "+" "+sDescription[i]+" "+rating;
      //Print( info );
   
      color c=Yellow ;
   
      if (sCurrency[i] == "USD") c = Aqua;  
      if (sCurrency[i] == "EUR") c = Pink; 
      if (sCurrency[i] == "GBP") c = Red;
      if (sCurrency[i] == "JPY") c = Orange;            
      if (sCurrency[i] == "AUD") c = Green;       
      if (sCurrency[i] == "CAD") c = Gray;
      if (sCurrency[i] == "CHF") c = Green;
      if (sCurrency[i] == "NZD") c = Lime;  
      
         if (DisplayText)
         {
           ObjectDelete("TSDT"+i);
           if (cntry1 == sCurrency[i] || cntry2 == sCurrency[i])
           {             
             ObjectCreate("TSDT"+i, OBJ_TEXT, 0, dt[i], Close[0]);
             ObjectSet("TSDT"+i, OBJPROP_COLOR, c);          
             ObjectSetText("TSDT"+i,sCurrency[i] + " " + sDescription[i] + " ",8);          
             ObjectSet("TSDT"+i, OBJPROP_ANGLE, 90);          
           }
         }
          
         if (DisplayLine)
         {   
           ObjectDelete("TSDL"+i);      
           if (cntry1 == sCurrency[i] || cntry2 == sCurrency[i])
           {         
             
             ObjectCreate("TSDL"+i, OBJ_VLINE, 0, dt[i], Close[0]);
             ObjectSet("TSDL"+i, OBJPROP_COLOR, c);                    
             ObjectSet("TSDL"+i, OBJPROP_STYLE, STYLE_DOT);                    
             ObjectSet("TSDL"+i, OBJPROP_BACK, true);          
             ObjectSetText("TSDL"+i,sDescription[i] + "  ",8);          
           }
         }
      }
   i++;
   }
   NewsNum = i-1;
   //Print("Num=",NewsNum);
return(0);
}

//----
void ObjDel()
{
   int _GetLastError;
   if(DisplayLine && DisplayText) int obtotal = 0.5*ObjectsTotal(); else obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
      if (DisplayLine)
      if ( !ObjectDelete( StringConcatenate( "TSDL", i ) ) )
      {
      _GetLastError = GetLastError();
      //Print( "ObjectDelete( \"", StringConcatenate( "TSDL", i ),"\" ) - Error #", _GetLastError );
      }
      
      if (DisplayText)
      if( !ObjectDelete( StringConcatenate( "TSDT", i ) ) )
      {
      _GetLastError = GetLastError();
      //Print( "ObjectDelete( \"", StringConcatenate( "TSDT", i ),"\" ) - Error #", _GetLastError );
      }
   }
}

string ForexTSD_Calendar()
{
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartDate+"&calendar[]="+CalendarID;
   string result = forextsd_com_webget(WebAdress);
      
   if(result != "") 
   {
   if(Day()<10) string day = "0"+Day();
   else day = Day();
   
   if(Month()<10) string month = "0"+Month();
   else month = Month(); 
   
   string CalName = CalendarName+"_"+Year()+"-"+ month+"-"+day+".csv";
   
   Print(CalName," is OK");
   int handle=FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";

   return(CalName);   
}

void ChartComment()
{
   string sComment   = "";
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   for (int i=0; i<=NewsNum-1; i++)
   { 
   datetime PrevTime = dt[i-1];
   datetime OpenTime = dt[i];
   
      if(TimeCurrent()> PrevTime && TimeCurrent() <= OpenTime)
      {
      string upcomCurr = sCurrency[i];
      string upcomNews = sCurrency[i]+" "+sDescription[i]; 
      string upcomTime = TimeToStr(dt[i]);
         if(i+1 <= NewsNum-1)
         {
         string nextCurr = sCurrency[i+1];
         string nextNews = sCurrency[i+1]+" "+sDescription[i+1];
         string nextTime = TimeToStr(dt[i+1]);
         }
      break;
      }
   }
   
   sComment = sp;
   sComment = sComment+"ForexTSD Calendar:"+NL;
   sComment = sComment+"News :" + NL;
   //if (cntry1 == upcomCurr || cntry2 == upcomCurr)
     sComment = sComment+"Upcoming = " + upcomTime +" "+upcomNews + NL;
   //if (cntry1 == nextCurr || cntry2 == nextCurr)  
     sComment = sComment+"Next = " + nextTime +" "+nextNews + NL;
   sComment = sComment+sp;
  
   Comment(sComment);
}      

bool TimeToAlert()
{
   bool result = false;
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime AlertTime = dt[i] - AlertTimeGap*60;
   
      if((TimeCurrent()>= AlertTime && TimeCurrent() <= AlertTime + 60))
      {result=true; break;}
   }
   return(result);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjDel();
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   datetime cTime = iTime(NULL,PERIOD_W1,0);
   
   if (fTime || (TimeCurrent() > cTime && cTime > prevTime))
   {
   string cName = ForexTSD_Calendar();  
      
      if(cName != "")
      {   
      ReadnPlotCalendar(cName);
      fTime = false;
      prevTime = cTime;
      }
      else 
      {
      //Print("Attention! Wrong Calendar!"); 
      return(0);
      }
   }
   
   if(AlertMode && TimeToAlert() && TimeCurrent() > nTime) 
   {
   Alert("Upcoming News! Be ready!"); 
   nTime = TimeCurrent() + AlertTimeGap*60;
   }
   ChartComment();   

//----

   return(0);
  }
//+------------------------------------------------------------------+